local PANEL = {}

function PANEL:Init()

	self:SetMouseInputEnabled( false )
	self:SetKeyboardInputEnabled( false )
	
	self:SetSize( ScrW(), ScrH() )
	self:SetPos( 0, 0 )
	
	self.SnowFlakes = {}
	
	self.SnowMaterials = {}
	for i=1,24 do
		self.SnowMaterials[i] = Material( "blackops/snowflakes/"..i )
	end
	
	for i=1,math.random( 25, 50 ) do
		self:AddSnowFlake()
	end
	
end

function PANEL:SetVariables( pnl )
	pnl:SetSize( 64, 64 )
	pnl.MyMaterial = self.SnowMaterials[ math.random( 1, 24 ) ]
	pnl.xOff = math.random( 0, ScrW()-pnl:GetWide() )
	pnl.Speed = math.random( 70, 200 )
	pnl.StartTime = SysTime()
	pnl.SinHeight = pnl.Speed/math.random( 1, 4 )
end

function PANEL:AddSnowFlake()
	self.SnowFlake = vgui.Create("DPanel", self)
	self:SetVariables( self.SnowFlake )
	self.SnowFlake.Paint = function( pnl ) --Yay rotations!
		surface.SetDrawColor( 255, 255, 255 ,255 )
		surface.SetMaterial( pnl.MyMaterial )
		surface.DrawTexturedRectRotated( 32, 32, pnl:GetWide(), pnl:GetTall(), math.cos(pnl.StartTime - SysTime()) * pnl.SinHeight/2 )
	end
	table.insert( self.SnowFlakes, self.SnowFlake )
end

function PANEL:Think()
	for k,v in ipairs( self.SnowFlakes ) do
		if IsValid( v ) then
			local h = ScrH()
			local yOff = 0 - (v.StartTime - SysTime()) * v.Speed - v:GetTall()
			if ( yOff > h ) then --When it reaches the bottom we fake the creation of a new snowflake
				self:SetVariables( v )
			end
			v:SetPos( v.xOff + math.cos(v.StartTime - SysTime()) * v.SinHeight, yOff )
		end
	end
end

local flakebackground = vgui.CreateFromTable( vgui.RegisterTable( PANEL, "Panel" ) )

concommand.Add("snowflake_add", function(ply,cmd,args)
	local amounttoadd = args[1] and tonumber( args[1] ) or 1
	
	for i=1,amounttoadd do
		flakebackground:AddSnowFlake()
	end
end )

concommand.Add("snowflake_remove_all", function(ply,cmd,args)
	for k,v in ipairs( flakebackground.SnowFlakes ) do
		v:Remove()
	end
end )